﻿init python:
    import random
    import time
    random.seed(time.time())
    def get_pixel(image, x, y):
        img = renpy.load_surface(image)
        return img.get_at((x, y))

    class darts_bar(renpy.Displayable):
        def __init__(self, image):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = 0
            self.y = 0
            self.x_direction = 8
            self.y_direction = 8
            self.x_moving = False
            self.y_moving = False
            self.limit = 450
            self.speed = 8
        def render(self,width,height,st,at):
            if self.y > self.limit:
                self.y_direction = -self.speed
            elif self.y < -self.limit:
                self.y_direction = self.speed
            
            if self.x > self.limit:
                self.x_direction = -self.speed
            elif self.x < -self.limit:
                self.x_direction = self.speed
            if self.y_moving:
                self.y += self.y_direction
            if self.x_moving:
                self.x += self.x_direction

            t = Transform(self.image, xanchor=0.5, yanchor=0.5)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x, self.y))

            renpy.redraw(self, 0)
            return rv
    class darts_class:
        def __init__(self, board):
            self.board = board
            self.bottom_arrow = darts_bar("darts_bottom_arrow")
            self.bottom_arrow.y = 450
            self.side_arrow = darts_bar("darts_side_arrow")
            self.side_arrow.x = -450
            self.darts = ["dart_dart_1", "dart_dart_2", "dart_dart_3"]
        def take(self, dart):
            self.darts.append(dart)
            Hide(dart)()
        def throw(self):
            if not len(self.darts):
                return
            x = self.bottom_arrow.x
            y = self.side_arrow.y
            r = random.randint(0,180)
            tag = self.darts.pop()
            Show("darts_dart_screen", x = x, y = y, r = r, tag = tag, g = self, _tag = tag)()
            
            pixel = get_pixel("images/darts_zones.png", x+960, y+540)
            renpy.notify(pixel)
        def clicked(self):
            if not len(self.darts):
                return
            if self.bottom_arrow.x_moving:
                self.bottom_arrow.x_moving = False
                self.side_arrow.y_moving = True
            elif self.side_arrow.y_moving:
                self.side_arrow.y_moving = False
                self.throw()
            else:
                self.start()
        def start(self):
            self.bottom_arrow.x_moving = True
            
transform dart_dart_animation(x,y,r):
    xoffset random.randint(0,100)
    yoffset random.randint(400,500)
    rotate 0
    zoom 3
    parallel:
        ease_circ .4 xoffset x yoffset y zoom 1
    parallel:
        linear .4 rotate r
screen darts_dart_screen(x, y, r, tag, g):
    button:
        align .5,.5 at dart_dart_animation(x, y, r)
        add "dart_dart"
        action Function(g.take, tag)
screen darts_screen():
    modal True
    default g = darts_class(None)

    add g.bottom_arrow align .5,.5
    add g.side_arrow align .5,.5

    button:
        action Function(g.clicked)




label darts_example:
    scene black
    show darts_board with dissolve
    call screen darts_screen








